> For the complete documentation index, see [llms.txt](https://mariadb.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://mariadb.com/docs/server/reference/clientserver-protocol/3-binary-protocol-prepared-statements/com_stmt_bulk_execute.md).

# COM\_STMT\_BULK\_EXECUTE

Executes a bulk insert of a previously prepared statement.

A command that returns a result set returns an error (Error packet).

## Direction

Client to server.

## Fields

* [int<1>](/docs/server/reference/clientserver-protocol/protocol-data-types.md#fixed-length-integers) `0xfa` : `COM_STMT_BULK_EXECUTE` header.
* [int<4>](/docs/server/reference/clientserver-protocol/protocol-data-types.md#fixed-length-integers) statement id.
* [int<2>](/docs/server/reference/clientserver-protocol/protocol-data-types.md#fixed-length-integers) [bulk flags](#bulk-flags).
* If (`bulk_flag` & `SEND_TYPES_TO_SERVER`):
  * For each parameter:
    * byte<1>: [field type](/docs/server/reference/clientserver-protocol/4-server-response-packets/result-set-packets.md).
    * byte<1>: [parameter type flag](#parameter-type-flag).
* Until end of packet:
  * For each parameter (i.e `param_count` times):
    * byte<1>: [parameter indicator](#parameter-indicator).
    * If indicator == `NONE`:
      * byte\<n> : binary parameter value.

## Flags

### Bulk Flags

| Flag                   | Value | Details                                                                                                                                          |
| ---------------------- | ----- | ------------------------------------------------------------------------------------------------------------------------------------------------ |
| `SEND_UNIT_RESULTS`    | 64    | Return generated affected rows and auto-increment IDs as a result set (only when server supports `MARIADB_CLIENT_BULK_UNIT_RESULTS` capability). |
| `SEND_TYPES_TO_SERVER` | 128   | Send types to server.                                                                                                                            |

### Parameter Type Flag

|     |          |
| --- | -------- |
| 128 | unsigned |

### Parameter Indicator

|   |           |                                                    |
| - | --------- | -------------------------------------------------- |
| 0 | `NONE`    | Value follow                                       |
| 1 | `NULL`    | Value is null                                      |
| 2 | `DEFAULT` | For `INSERT`/`UPDATE`, value is default            |
| 3 | `IGNORE`  | Value is default for insert, Is ignored for update |

## Response

The server can answer with 3 different responses:

* `0xff`: [ERR\_Packet](/docs/server/reference/clientserver-protocol/4-server-response-packets/err_packet.md) if any errors occur.
* `0x00`: [OK\_packet](/docs/server/reference/clientserver-protocol/4-server-response-packets/ok_packet.md) when query execution works without result set.
* A result set containing affected rows and auto-increment IDs when bulk flag `SEND_UNIT_RESULTS` is set.

<sub>*This page is licensed: CC BY-SA / Gnu FDL*</sub>

{% @marketo/form formId="4316" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://mariadb.com/docs/server/reference/clientserver-protocol/3-binary-protocol-prepared-statements/com_stmt_bulk_execute.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
